/**
 * @file cuda_stubs.c
 * @brief Stubs for a no-CUDA build.
 * @author Jakub Kurzak
 *
 * PULSAR Runtime
 * http://icl.utk.edu/pulsar/
 * Copyright (C) 2012-2015 University of Tennessee.
 */

#include "cuda_stubs.h"

#ifndef CUDA

static void quit()
{
    printf("PRT ERROR: PRT built without CUDA\n)");
    abort();
}

cudaError_t cudaSetDevice(int device) {quit();}
cudaError_t cudaGetDevice(int* device) {quit();}
cudaError_t cudaFree(void* devPtr) {quit();}
cudaError_t cudaMalloc(void** devPtr, size_t size) {quit();}
cudaError_t cudaMemGetInfo(size_t* free, size_t* total) {quit();}
cudaError_t cudaStreamDestroy(cudaStream_t stream)   {quit();}
cudaError_t cudaStreamCreateWithFlags(cudaStream_t* pStream, unsigned int flags) {quit();}
cudaError_t cudaStreamAddCallback(cudaStream_t stream, cudaStreamCallback_t callback, void* userData, unsigned int flags) {quit();}
cudaError_t cudaEventCreate(cudaEvent_t* event) {quit();}
cudaError_t cudaEventRecord(cudaEvent_t event, cudaStream_t stream) {quit();}
cudaError_t cudaEventElapsedTime(float* ms, cudaEvent_t start, cudaEvent_t end) {quit();}
cudaError_t cudaMemcpyAsync(void* dst, const void* src, size_t count, cudaMemcpyKind kind, cudaStream_t stream) {quit();}
cudaError_t cudaMemcpyPeerAsync(void* dst, int dstDevice, const void* src, int srcDevice, size_t count, cudaStream_t stream) {quit();}
cudaError_t cudaDeviceSynchronize(void) {quit();}
const __cudart_builtin__ char* cudaGetErrorString(cudaError_t error) {quit();}

#endif /* CUDA */
