/**
 * @file mpi_stubs.c
 * @brief Stubs for a no-MPI build.
 * @author Jakub Kurzak
 *
 * PULSAR Runtime
 * http://icl.utk.edu/pulsar/
 * Copyright (C) 2012-2015 University of Tennessee.
 */

#include "mpi_stubs.h"

#ifndef MPI

static void quit()
{
    printf("PRT ERROR: PRT built without MPI\n)");
    abort();
}

int MPI_Initialized(int *flag)
{
    *flag = 0;
    return MPI_SUCCESS;
}

int MPI_Comm_rank(MPI_Comm comm, int *rank)
{
    *rank = 0;
    return MPI_SUCCESS; 
}

int MPI_Comm_size(MPI_Comm comm, int *size)
{
    *size = 1;
    return MPI_SUCCESS;
}

int MPI_Barrier(MPI_Comm comm)
{
    return MPI_SUCCESS; 
}

int MPI_Cancel(MPI_Request *request) {quit();}
int MPI_Abort(MPI_Comm comm, int errorcode) {quit();}
int MPI_Test(MPI_Request *request, int *flag, MPI_Status *status) {quit();}
int MPI_Get_count(const MPI_Status *status, MPI_Datatype datatype, int *count) {quit();}
int MPI_Send(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm) {quit();}
int MPI_Recv(void *buf, int count, MPI_Datatype datatype, int source, int tag, MPI_Comm comm, MPI_Status *status) {quit();}
int MPI_Irecv(void *buf, int count, MPI_Datatype datatype, int source, int tag, MPI_Comm comm, MPI_Request *request) {quit();}
int MPI_Isend(const void *buf, int count, MPI_Datatype datatype, int dest, int tag, MPI_Comm comm, MPI_Request *request) {quit();}
int MPI_Reduce(const void *sendbuf, void *recvbuf, int count, MPI_Datatype datatype, MPI_Op op, int root, MPI_Comm comm) {quit();}

#endif /* MPI */