/**
 * @file prt_assert.h
 * @brief PRT exception handling.
 * @author Jakub Kurzak
 *
 * PULSAR Runtime
 * http://icl.utk.edu/pulsar/
 * Copyright (C) 2012-2015 University of Tennessee.
 */

#ifndef PRT_ASSERT_H
#define PRT_ASSERT_H

#include "prt.h"

#ifdef __cplusplus
extern "C" {
#endif

void prt_error_line_file(const char *msg, int line, char *file);
void prt_warning_line_file(const char *msg, int line, char *file);
void prt_assert_line_file(int cond, const char *msg, int line, char *file);

#define prt_error(msg) \
    prt_error_line_file(msg, __LINE__, __FILE__)

#define prt_warning(msg) \
    prt_warning_line_file(msg, __LINE__, __FILE__)

#define prt_assert(cond, msg) \
    prt_assert_line_file(cond, msg, __LINE__, __FILE__)

#ifdef __cplusplus
}
#endif

#endif /* PRT_ASSERT_H */
