/**
 * @file prt_transfer.h
 * @brief PRT local transfer.
 * @author Jakub Kurzak
 *
 * PULSAR Runtime
 * http://icl.utk.edu/pulsar/
 * Copyright (C) 2012-2015 University of Tennessee.
 */

#ifndef PRT_TRANSFER_H
#define PRT_TRANSFER_H

#include "prt.h"

#ifdef __cplusplus
extern "C" {
#endif

/**
 * @brief Local transfer object.
 */
typedef struct prt_transfer_s {
    struct prt_packet_s *packet;    // Source packet.
    struct prt_channel_s *channel;  // Destination channel.
    prt_direction_t direction;      // Transfer direction.
    int agent;                      // Transfer agent.
} prt_transfer_t;

prt_transfer_t *prt_transfer_new(
    struct prt_packet_s *packet,
    struct prt_channel_s *channel,
    prt_direction_t direction,
    int agent);
void prt_transfer_delete(prt_transfer_t *transfer);

#ifdef __cplusplus
}
#endif

#endif /* PRT_TRANSFER_H */
